<!-- 
{{ $content := .Inner }} 
{{ $ident := partial "form/attr/ident.tpl" . }}
{{ $class := partial "form/attr/get.tpl" (slice . "class") }}
{{ $task := partial "form/attr/get.tpl" (slice . "task") }}
{{ $folder := partial "form/attr/get.tpl" (slice . "extends") | default $ident }}
{{ $params := index .Page.Params "forms" $folder }}
{{ $stored := index $.Site.Data.forms $folder }}
{{ $partial := partial "form/attr/get.tpl" (slice . "partial") }}
{{ $script := partial "form/attr/get.tpl" (slice . "script") }}
{{ $scripts := partial "form/attr/get.tpl" (slice . "scripts") | default slice }}
{{ $debug := partial "form/attr/debug.tpl" . }}
{{ if eq "string" (printf "%T" $scripts) }}
  {{ $scripts = $scripts | transform.Unmarshal }}
{{ end }}
{{ if $script }}
  {{ $scripts = $scripts | append $script }}
{{ end }}
-->


<!-- Load the required scripts -->
<!--{{ range $path := $scripts }}-->
<!--{{ $js := resources.Get $path | js.Build  }}-->
<script type="text/javascript" src="{{ $js.RelPermalink }}"></script>
<!--{{ end }}-->

<form
  id="{{ $ident }}"
  class='{{ $class | default "workflow max-w-7xl" }}'
  x-data="{
    view: null,
    task: {{ $task | jsonify }},
    load: {
      task: {{ partial `form/attr/get.tpl` (slice . `load` `load.task`) | jsonify }},
      data: {{ partial `form/attr/get.tpl` (slice . `load-data` `load.data`) | jsonify }},
      schema: {{ partial `form/attr/get.tpl` (slice . `load-schema` `load.schema`) | jsonify }},
      uischema: {{ partial `form/attr/get.tpl` (slice . `load-uischema` `load.uischema`) | jsonify }},
    },
    form: new FormController('{{ $ident }}', {      
      data: {{ default $params.data $stored.data | jsonify }},
      schema: {{ default $params.schema $stored.schema | jsonify }},
      uischema: {{ default $params.uischema $stored.uischema | jsonify }},
      debug: {{ $debug | jsonify }},
    }),
  }"
  x-bind:disabled="form?.loading"
  @submit.prevent="await form.submit($el, task)"
>
  <!-- Do not even load the form if the user is not logged in  -->
  <template x-if="App.Auth && !App.Auth.isAuthenticated()">
    <div class="py-8">{{ partial "user/login" . }}</div>
  </template>

  <!-- Load form with the provided data -->
  <template x-if="!form.pipeline && App?.Auth?.isAuthenticated()">
    <div class="relative">
      <!--         
        {{ if $partial }}
          {{ $content = partial $partial . }} 
        {{ end }}
      -->      
      <div 
        x-init="await form.bootstrap($el, load)"
        :class="{ 'opacity-25': form?.loading }"
      >{{- $content -}}</div>
      <!-- Form loading overlay -->
      <div
        x-cloak
        x-show="form?.loading"
        class="absolute top-0 bottom-0 left-0 right-0 flex justify-items-center items-center"
      >
        <div class="inline-block mx-auto space-x-2 text-3xl">
          <i class="fa-solid fa-arrows-rotate fa-spin"></i>
          <span>Loading...</span>
        </div>
      </div>
    </div>
  </template>

  <!-- Show the status of the current pipeline -->
  <template x-if="form?.pipeline">
    <div x-data="form">{{ partial "workflow/details/pipeline" . }}</div>
  </template>

  <!-- Optional footer if no submit button is detected -->
  <template x-if="!form.pipeline && form.hasFooter">
    <div
      class="flex space-x-3 justify-end border-t border-gray-200 dark:border-gray-800 px-8 py-4 text-right"
    >
      <div x-show="form?.debug">{{ partial "form/controls/debug" . }}</div>
      <div class="flex-1">{{ partial "form/controls/default" . }}</div>
    </div>
  </template>

  <template x-if="form.debug && !form?.pipeline">{{ partial "form/debug" . }}</template>
</form>